# Class MapTransformCollection<T, U>

A collection that is produced by passing the items of an existing collection through a callback. Unlike Collection.map() which produces a snapshot, a MapTransformCollection maintains a link to the original collection, changing when the original collection changes and emitting change events. This collection is read-only.

#### Type Parameters

- T
- U

#### Hierarchy (view full)

- ReadOnlyCollection<U>
  - MapTransformCollection

#####
Index

### Constructors

constructor

### Accessors

_collection
declaredClass
destroyed
initialized
length

### Methods

_get
_set
[iterator]
add
addHandles
addMany
at
clone
concat
destroy
every
filter
find
findIndex
flatten
forEach
get
getItemAt
hasHandles
includes
indexOf
join
lastIndexOf
map
notifyChange
on
pop
push
reduce
reduceRight
remove
removeAll
removeAt
removeHandles
removeMany
reorder
reverse
set
shift
slice
some
sort
splice
toArray
unshift
watch

##
Constructors

### constructor

- new MapTransformCollection<T, U>(originalCollection, callback): MapTransformCollection<T, U>

- #### Type Parameters

  - T
  - U

  #### Parameters

  - originalCollection: Collection<T>
  - callback: ((item: T) => U)
    - - (item): U

      - #### Parameters

        - item: T

        #### Returns U

  #### Returns MapTransformCollection<T, U>

  Overrides ReadOnlyCollection.constructor

##
Accessors

### `Protected`_collection

- get _collection(): Collection<U>

- The underlying collection that this class delegates to.

  #### Returns Collection<U>

  Overrides ReadOnlyCollection._collection

### declaredClass

- get declaredClass(): string

- The declared class name. This is always `"esri.core.Collection"` for compatibility with Esri's API.

  #### Returns string

  Inherited from ReadOnlyCollection.declaredClass

### destroyed

- get destroyed(): boolean

- Whether the collection has been destroyed.

  #### Returns boolean

  Inherited from ReadOnlyCollection.destroyed

- set destroyed(value): void

- #### Parameters

  - value: boolean

  #### Returns void

  Inherited from ReadOnlyCollection.destroyed

### initialized

- get initialized(): boolean

- Whether the collection has been initialized.

  #### Returns boolean

  Inherited from ReadOnlyCollection.initialized

- set initialized(value): void

- #### Parameters

  - value: boolean

  #### Returns void

  Inherited from ReadOnlyCollection.initialized

### length

- get length(): number

- The number of items in the collection.

  #### Returns number

  Inherited from ReadOnlyCollection.length

##
Methods

### `Protected`_get

- _get(propertyName): any

- #### Parameters

  - propertyName: string

  #### Returns any

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Inherited from ReadOnlyCollection._get

- _get<T>(propertyName): T

- #### Type Parameters

  - T

  #### Parameters

  - propertyName: string

  #### Returns T

  Inherited from ReadOnlyCollection._get

### `Protected`_set

- _set<T>(propertyName, value): this

- #### Type Parameters

  - T

  #### Parameters

  - propertyName: string
  - value: T

  #### Returns this

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Inherited from ReadOnlyCollection._set

### [iterator]

- [iterator](): IterableIterator<U, any, any>

- #### Returns IterableIterator<U, any, any>

  #### Inherit Doc

  Inherited from ReadOnlyCollection.[iterator]

### add

- add(_item, _index?): this

- Adds a single item to the collection.

  #### Parameters

  - _item: U
  - `Optional`_index: number

  #### Returns this

  Inherited from ReadOnlyCollection.add

### addHandles

- addHandles<T>(handles, groupKey?): void

- #### Type Parameters

  - T

  #### Parameters

  - handles: IHandle | IHandle[]
  - `Optional` groupKey: Exclude<T, IHandle>

  #### Returns void

  Inherited from ReadOnlyCollection.addHandles

### addMany

- addMany(items, index?): this

- Adds multiple items to the collection.

  #### Parameters

  - items: Collection<U> | ArrayLike<U>

    An array or collection of items to add.

  - `Optional` index: number

    Zero-based index of where in the collection to add the items. If not specified, the items will be added at the end.

  #### Returns this

  Inherited from ReadOnlyCollection.addMany

### at

- at(index): U

- Returns the item at the specified index.

  #### Parameters

  - index: number

    Zero-based index of the item in the Collection to retrieve.

  #### Returns U

  The item in the Collection stored at the specified index.

  Inherited from ReadOnlyCollection.at

### clone

- clone(): Collection<U>

- Creates a deep clone of the Collection. To create a shallow clone of the collection, use slice().

  #### Returns Collection<U>

  Inherited from ReadOnlyCollection.clone

### concat

- concat(value): Collection<U>

- Creates a new Collection containing the items in the original Collection joined with the items in the input array or Collection.

  #### Parameters

  - value: Collection<U> | U[]

    The array or Collection to append to the existing Collection.

  #### Returns Collection<U>

  Inherited from ReadOnlyCollection.concat

### destroy

- destroy(): void

- Removes all event listeners and destroys the collection.

  #### Returns void

  Inherited from ReadOnlyCollection.destroy

### every

- every(callback): boolean

- Determines whether all items in the Collection pass a test defined by callback. Each item in the Collection is passed into the callback until one returns a value of false.

  #### Parameters

  - callback: ItemTestCallback<U>

    The function to call for each item in the Collection.

  #### Returns boolean

  Inherited from ReadOnlyCollection.every

### filter

- filter(callback): Collection<U>

- Filters the Collection's items based on a test defined by the callback function. Each item is passed into the callback function, which returns true if the item passes the test and false if it does not.

  #### Parameters

  - callback: ItemTestCallback<U>

    The function that defines a test for determining whether to return the item in a new Collection.

  #### Returns Collection<U>

  Inherited from ReadOnlyCollection.filter

### find

- find(callback): U

- Returns an item in the Collection if that item passes a test as defined in the callback function. Each item is passed into the callback function, which returns true if the item passes the test and false if it does not.

  #### Parameters

  - callback: ItemTestCallback<U>

    The testing function that will assess each item in the Collection. Returns true if an item passes the test and false if it fails.

  #### Returns U

  Inherited from ReadOnlyCollection.find

### findIndex

- findIndex(callback): number

- Returns the index of an item in the Collection if that item passes a test as defined in the callback function. Each item is passed into the callback function, which returns true if the item passes the test and false if it does not.

  #### Parameters

  - callback: ItemTestCallback<U>

    The testing function that will assess each item in the Collection. Returns true if an item passes the test and false if it fails.

  #### Returns number

  Returns the index of the Collection item that satisfies the test function. If an item fails the test, -1 is returned.

  Inherited from ReadOnlyCollection.findIndex

### flatten

- flatten(callback): Collection<U>

- Flattens a hierarchical Collection containing at least one child collection. Each item in the collection is passed into the callback function, which should check for child collections specified by the developer. A flat collection of all items (parent and children) is returned.

  #### Parameters

  - callback: ((item: U, index: number) => Collection<U> | U[])

    A function that will assess each item in the Collection.

    - - (item, index): Collection<U> | U[]

      - #### Parameters

        - item: U
        - index: number

        #### Returns Collection<U> | U[]

  #### Returns Collection<U>

  Inherited from ReadOnlyCollection.flatten

### forEach

- forEach(callback): void

- Executes the input function for each item in the Collection.

  #### Parameters

  - callback: ItemCallback<U>

    The function to call for each item in the Collection.

  #### Returns void

  Inherited from ReadOnlyCollection.forEach

### get

- get<T>(propertyPath): T

- #### Type Parameters

  - T

  #### Parameters

  - propertyPath: string

  #### Returns T

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Inherited from ReadOnlyCollection.get

- get(propertyPath): unknown

- #### Parameters

  - propertyPath: string

  #### Returns unknown

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Inherited from ReadOnlyCollection.get

### getItemAt

- getItemAt(index): U

- Returns the item at the specified index.

  #### Parameters

  - index: number

    Zero-based index of the item in the Collection to retrieve.

  #### Returns U

  The item in the Collection stored at the specified index.

  Inherited from ReadOnlyCollection.getItemAt

### hasHandles

- hasHandles<T>(groupKey?): boolean

- #### Type Parameters

  - T

  #### Parameters

  - `Optional` groupKey: Exclude<T, IHandle>

  #### Returns boolean

  Inherited from ReadOnlyCollection.hasHandles

### includes

- includes(searchElement): boolean

- Tests if an item is present in the Collection.

  #### Parameters

  - searchElement: U

    The item to search for in the collection.

  #### Returns boolean

  Inherited from ReadOnlyCollection.includes

### indexOf

- indexOf(searchElement, fromIndex?): number

- Returns the index of an element in the collection.

  #### Parameters

  - searchElement: U

    Item to search for in the collection.

  - `Optional` fromIndex: number

    Use if you don't want to search the whole collection or you don't want to search from the start.

  #### Returns number

  Inherited from ReadOnlyCollection.indexOf

### join

- join(separator?): string

- Creates a string representation of the items in the Collection.

  #### Parameters

  - `Optional` separator: string

    The separator used between each item in the final string. The default is ",".

  #### Returns string

  Inherited from ReadOnlyCollection.join

### lastIndexOf

- lastIndexOf(searchElement, fromIndex?): number

- Returns the last index of an element in the collection.

  #### Parameters

  - searchElement: U

    Item to search for in the collection.

  - `Optional` fromIndex: number

    Use if you don't want to search the whole collection, or you don't want to search from the end.

  #### Returns number

  The location of the last match found in the collection, or -1 if there is no match.

  Inherited from ReadOnlyCollection.lastIndexOf

### map

- map<U>(callback): Collection<U>

- Passes each Collection item into the callback function and returns a new array of the returned values.

  #### Type Parameters

  - U

  #### Parameters

  - callback: ItemMapCallback<U, U>

    The function that processes each item in the Collection and returns a new value at the same index of the original item.

  #### Returns Collection<U>

  Inherited from ReadOnlyCollection.map

### `Protected` notifyChange

- notifyChange(propertyKey): void

- #### Parameters

  - propertyKey: string

  #### Returns void

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Inherited from ReadOnlyCollection.notifyChange

- notifyChange(propertyKey): void

- #### Parameters

  - propertyKey: keyof MapTransformCollection<T, U>

  #### Returns void

  Inherited from ReadOnlyCollection.notifyChange

### on

- on(type, listener): IHandle

- #### Parameters

  - type: "after-add"
  - listener: CollectionAfterAddEventHandler<U>

  #### Returns IHandle

  #### Inherit Doc

  Inherited from ReadOnlyCollection.on

- on(type, listener): IHandle

- #### Parameters

  - type: "after-changes"
  - listener: CollectionAfterChangesEventHandler

  #### Returns IHandle

  Inherited from ReadOnlyCollection.on

- on(type, listener): IHandle

- #### Parameters

  - type: "after-remove"
  - listener: CollectionAfterRemoveEventHandler<U>

  #### Returns IHandle

  Inherited from ReadOnlyCollection.on

- on(type, listener): IHandle

- #### Parameters

  - type: "before-add"
  - listener: CollectionBeforeAddEventHandler<U>

  #### Returns IHandle

  Inherited from ReadOnlyCollection.on

- on(type, listener): IHandle

- #### Parameters

  - type: "before-changes"
  - listener: CollectionBeforeChangesEventHandler

  #### Returns IHandle

  Inherited from ReadOnlyCollection.on

- on(type, listener): IHandle

- #### Parameters

  - type: "before-remove"
  - listener: CollectionBeforeRemoveEventHandler<U>

  #### Returns IHandle

  Inherited from ReadOnlyCollection.on

- on(type, listener): IHandle

- #### Parameters

  - type: "change"
  - listener: CollectionChangeEventHandler<U>

  #### Returns IHandle

  Inherited from ReadOnlyCollection.on

- on(type, listener): IHandle

- #### Parameters

  - type: string
  - listener: EventHandler

  #### Returns IHandle

  Inherited from ReadOnlyCollection.on

### pop

- pop(): U

- Removes the last item from the collection and returns it.

  #### Returns U

  Inherited from ReadOnlyCollection.pop

### push

- push(item): number

- Adds an item to the end of the collection.

  #### Parameters

  - item: U

    The item to add.

  #### Returns number

  Inherited from ReadOnlyCollection.push

### reduce

- reduce<U>(callback, initialValue?): U

- Reduces all items in the collection (from left to right) into a single variable using callback.

  #### Type Parameters

  - U

  #### Parameters

  - callback: ItemReduceCallback<U, U>

    The function that processes each item in the Collection and appends it to the previous item.

  - `Optional` initialValue: U

    Item to use as the first element to process in callback.

  #### Returns U

  Inherited from ReadOnlyCollection.reduce

### reduceRight

- reduceRight<U>(callback, initialValue?): U

- Reduces all items in the collection (from right to left) into a single variable using callback.

  #### Type Parameters

  - U

  #### Parameters

  - callback: ItemReduceCallback<U, U>

    The function that processes each item in the Collection and appends it to the previous item.

  - `Optional` initialValue: U

    Item to use as the first element to process in callback.

  #### Returns U

  Inherited from ReadOnlyCollection.reduceRight

### remove

- remove(item): U

- Removes an item from the collection.

  #### Parameters

  - item: U

    The item to remove.

  #### Returns U

  Inherited from ReadOnlyCollection.remove

### removeAll

- removeAll(): U[]

- Removes all items from the collection.

  #### Returns U[]

  Inherited from ReadOnlyCollection.removeAll

### removeAt

- removeAt(_index): U

- Removes an item from the collection at a specified index.

  #### Parameters

  - _index: number

  #### Returns U

  Inherited from ReadOnlyCollection.removeAt

### removeHandles

- removeHandles<T>(groupKey?): void

- #### Type Parameters

  - T

  #### Parameters

  - `Optional` groupKey: Exclude<T, IHandle>

  #### Returns void

  Inherited from ReadOnlyCollection.removeHandles

### removeMany

- removeMany(items): U[]

- Removes each item in the input array. If an item is present multiple times in the collection, only the first occurrence is removed.

  #### Parameters

  - items: Collection<U> | ArrayLike<U>

    The items to remove.

  #### Returns U[]

  Inherited from ReadOnlyCollection.removeMany

### reorder

- reorder(_item, _index): U

- Moves an item in the Collection to a specified index. The change event is fired after an item is moved in the Collection.

  #### Parameters

  - _item: U
  - _index: number

  #### Returns U

  Inherited from ReadOnlyCollection.reorder

### reverse

- reverse(): this

- Reverses the collection in place.

  #### Returns this

  Inherited from ReadOnlyCollection.reverse

### set

- set<T>(propertyPath, value): this

- #### Type Parameters

  - T

  #### Parameters

  - propertyPath: string
  - value: T

  #### Returns this

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Inherited from ReadOnlyCollection.set

- set(properties): this

- #### Parameters

  - properties: HashMap<unknown>

  #### Returns this

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Inherited from ReadOnlyCollection.set

### shift

- shift(): U

- Removes the first item from the collection (at index 0), and returns it. The remaining items of the collection are then shifted down one index from their previous location.

  #### Returns U

  Inherited from ReadOnlyCollection.shift

### slice

- slice(begin?, end?): Collection<U>

- Creates a new Collection comprised of a portion of the original Collection.

  #### Parameters

  - `Optional` begin: number

    The index of the first item to extract.

  - `Optional` end: number

    The index of the last item to extract.

  #### Returns Collection<U>

  Inherited from ReadOnlyCollection.slice

### some

- some(callback): boolean

- Determines whether an item in the Collection passes a test defined by callback. Each item in the Collection is passed into the callback until one returns a value of true.

  #### Parameters

  - callback: ItemTestCallback<U>

    The function that defines the test for each Collection item.

  #### Returns boolean

  Inherited from ReadOnlyCollection.some

### sort

- sort(_compareFunction?): this

- Sorts the Collection in place.

  #### Parameters

  - `Optional`_compareFunction: ((a: U, b: U) => number)
    - - (a, b): number

      - #### Parameters

        - a: U
        - b: U

        #### Returns number

  #### Returns this

  Inherited from ReadOnlyCollection.sort

### splice

- splice(_start, _deleteCount, ..._items): U[]

- Removes existing items and/or adds new items to the collection.

  #### Parameters

  - _start: number
  - _deleteCount: number
  - `Rest`..._items: U[]

  #### Returns U[]

  An array of the deleted items formerly part of the collection.

  Inherited from ReadOnlyCollection.splice

### toArray

- toArray(): U[]

- Returns a new array object containing the Collection's items.

  #### Returns U[]

  Inherited from ReadOnlyCollection.toArray

### unshift

- unshift(item): number

- Adds an item to the beginning of the collection.

  #### Parameters

  - item: U

    The item to add.

  #### Returns number

  Inherited from ReadOnlyCollection.unshift

### watch

- watch(path, callback, sync?): IHandle

- #### Parameters

  - path: string | string[]
  - callback: ((newValue: any, oldValue: any, propertyName: string, target: any) => void)
    - - (newValue, oldValue, propertyName, target): void

      - #### Parameters

        - newValue: any
        - oldValue: any
        - propertyName: string
        - target: any

        #### Returns void

  - `Optional` sync: boolean

  #### Returns IHandle

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Inherited from ReadOnlyCollection.watch